# legacydeveloper Uiapi - Full Documentation # Action The actions for a single record or a collection of records. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | actions | Map | A map of record IDs to the actions for each record. | Small, 41.0 | 41.0 | | url | String | The URL of the current request. | Big, 41.0 | 41.0 | #### See Also - [Get Related List Actions with a Request Body](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_actions_get.htm "Get the actions on related lists for a record detail page. This resource uses the POST method so you can enter request parameters in the request body instead using complex URL parameters.") # Action Input Get the actions on related lists on a record detail page. JSON example To get information about related list actions on a record detail page, use this request with a request body. POST /services/data/v68.0/ui-api/actions/record/001R0000003IDlwIAG/related-list { "apiNames": \["New"\], "retrievalMode": "All" } Properties
Parameter Name Type Description Required or Optional Available Version
actionTypes String[] The action type. One or more of these values:
  • CustomButton—A button that opens a URL or Visualforce page or executes JavaScript.
  • ProductivityAction—A pre-defined Salesforce action, attached to a limited set of objects.
  • QuickAction—A global or object-specific action.
  • StandardButton—A pre-defined Salesforce button, such as New, Edit, and Delete.
Optional 57.0
apiNames String[] The API names of one or more actions to be retrieved. Use this parameter only when passing retrievalMode=All. Optional 57.0
formFactor String The layout display size. One of these values:
  • Large—(Default) Use this value to get a layout for desktop display size.
  • Medium—Use this value to get a layout for tablet display size.
  • Small—Use this value to get a layout for phone display size.
Optional 57.0
retrievalMode String When the action context is Record, this parameter indicates which actions to retrieve from the record page. One of these values:
  • All—Retrieves all actions specified in the apiNames parameter.
  • PageLayout—(Default) Retrieves actions from the page layout.
Optional 57.0
sections String[] The section of the user interface that the actions reside in. One or more of these values:
  • ActivityComposer
  • CollaborateComposer
  • Page
  • SingleActionLinks
Optional 57.0
#### See Also - [Get Related List Actions with a Request Body](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_actions_get.htm "Get the actions on related lists for a record detail page. This resource uses the POST method so you can enter request parameters in the request body instead using complex URL parameters.") # Action Related List Single Batch Input Get the actions on a batch of related lists for a record. JSON example To get information about the actions for the Contacts and Opportunities related lists on an Account record page, use this request with parameters in a request body. POST /services/data/v68.0/ui-api/actions/record/001R0000003IDlwIAG/related-list/batch { "relatedListsActionParameters": \[ { "relatedListId": "Contacts", "apiNames": \[ "New" \], "retrievalMode": "All" }, { "relatedListId": "Opportunities", "apiNames": \["New" \], "retrievalMode": "All" } \] } Properties
Parameter Name Type Description Required or Optional Available Version
actionTypes String[] The action type. One or more of these values:
  • CustomButton—A button that opens a URL or Visualforce page or executes JavaScript.
  • ProductivityAction—A pre-defined Salesforce action, attached to a limited set of objects.
  • QuickAction—A global or object-specific action.
  • StandardButton—A pre-defined Salesforce button, such as New, Edit, and Delete.
Optional 57.0
apiNames String[] The API names of one or more actions to be retrieved. Use this parameter only when passing retrievalMode=All. Optional 57.0
formFactor String The layout display size. One of these values:
  • Large—(Default) Use this value to get a layout for desktop display size.
  • Medium—Use this value to get a layout for tablet display size.
  • Small—Use this value to get a layout for phone display size.
Optional 57.0
relatedListId String The ID of the related list. Optional 57.0
retrievalMode String When the action context is Record, this parameter indicates which actions to retrieve from the record page. One of these values:
  • All—Retrieves all actions specified in the apiNames parameter.
  • PageLayout—(Default) Retrieves actions from the page layout.
Optional 57.0
sections String[] The section of the user interface that the actions reside in. One or more of these values:
  • ActivityComposer
  • CollaborateComposer
  • Page
  • SingleActionLinks
Optional 57.0
#### See Also - [Get a Batch of Related List Actions with a Request Body](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_actions_batch_get.htm "Get the actions on a batch of related lists for a record. This resource uses the POST method so you can enter request parameters in the request body instead using complex URL parameters.") # Action Related Lists Batch Input Get the actions on a batch of related lists for a record. JSON example To get information about the actions for the Contacts and Opportunities related lists on an Account record page, use this request with parameters in a request body. POST /services/data/v68.0/ui-api/actions/record/001R0000003IDlwIAG/related-list/batch { "relatedListsActionParameters": \[ { "relatedListId": "Contacts", "apiNames": \[ "New" \], "retrievalMode": "All" }, { "relatedListId": "Opportunities", "apiNames": \["New" \], "retrievalMode": "All" } \] } Properties | Parameter Name | Type | Description | Required or Optional | Available Version | | --- | --- | --- | --- | --- | | relatedListsActionParameters | [Action Related List Single Batch Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_action_related_list_single_batch_input.htm "Get the actions on a batch of related lists for a record.") | Parameters for each related list in the batch request. | Required | 57.0 | #### See Also - [Get a Batch of Related List Actions with a Request Body](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_actions_batch_get.htm "Get the actions on a batch of related lists for a record. This resource uses the POST method so you can enter request parameters in the request body instead using complex URL parameters.") # Actions Use these resources to get data and metadata about actions displayed in the Salesforce UI. Examples include standard and custom buttons, quick actions, and productivity actions. - **[Get Global Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_global.htm)** Get the actions in the Global Actions menu. - **[Get Record Detail Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_action_record.htm)** Get the actions on record detail pages. - **[Get Record Edit Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_action_record_edit.htm)** Get the actions on a record edit page. - **[Get Related List Actions with URL Parameters](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list.htm)** Get the actions on related lists on a record detail page via URL parameters. - **[Get Related List Actions with a Request Body](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_actions_get.htm)** Get the actions on related lists for a record detail page. This resource uses the POST method so you can enter request parameters in the request body instead using complex URL parameters. - **[Get a Batch of Related List Actions with URL Parameters](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_lists_batch.htm)** Get the actions on a batch of related lists for a record via URL parameters. - **[Get a Batch of Related List Actions with a Request Body](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_actions_batch_get.htm)** Get the actions on a batch of related lists for a record. This resource uses the POST method so you can enter request parameters in the request body instead using complex URL parameters. - **[Get Related List Record Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_record.htm)** Get the actions on records in related lists. - **[Get List View Header Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_list_view.htm)** Get the header actions on list views. - **[Get List View Record Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_list_view_record.htm)** Get the record actions on list views. - **[Get List View Chart Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_list_view_chart.htm)** Get the chart actions on list views. - **[Get Lightning Page Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_flexipage.htm)** Get the actions on Lightning pages (FlexiPages). - **[Get Lookup Field Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_lookup.htm)** Get the actions on lookup fields. - **[Get MRU List View Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_mru_list.htm)** Get the header actions on the most recently used (MRU) list view for objects. - **[Get Photo Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_photo.htm)** Get the photo actions for pages. Currently, only group and user pages support photo actions. - **[Get a Quick Action Layout](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_quick_action_layout.htm)** Get information about the record layout used by a Create a Record or Update a Record quick action. - **[Perform Quick Actions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_perform_action.htm)** Perform a quick action that creates or updates a record. - **[Update a Record with a Quick Action](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_update_action.htm)** Perform an Update a Record quick action. To perform a quick action that creates or updates a record, you can also use the POST method. # Advanced Lookup Display Info Search lookups advanced display information. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | fields | [Advanced Lookup Display Info Field](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_advanced_lookup_display_info_field.htm "Search lookups advanced display field information.")\[\] | Ordered list of advanced lookup display fields. | Small, 61.0 | 61.0 | # Advanced Lookup Display Info Field Search lookups advanced display field information. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | fieldPath | String | Advanced lookup display field path. | Small, 61.0 | 61.0 | | label | String | Advanced lookup display field label. | Small, 61.0 | 61.0 | | objectApiName | String | Advanced lookup display field object API name. | Small, 61.0 | 61.0 | # Advanced Lookup Info Advanced search lookup information. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | displayInfo | [Advanced Lookup Display Info](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_advanced_lookup_display_info.htm "Search lookups advanced display information.") | Advanced lookup display information. | Small, 61.0 | 61.0 | # All Supported Objects User Interface API supports many standard objects as well as all custom and external objects. For general information about the supported objects for UI API, see [Supported Objects](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_get_started_supported_objects.htm "User Interface API supports all custom objects and external objects and many standard objects."). This is a list of supported standard objects. As of Summer ’23, all new standard objects are auto-enabled for UI API usage. This list might not reflect the latest object support. To check if a specific object is supported, use the [/ui-api/object-info/{objectApiName} resource](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_get_started_supported_objects.htm "User Interface API supports all custom objects and external objects and many standard objects."). - AISentimentResult - Account - AccountBrand - AccountContactRelation - AccountForecast - AccountForecastAdjustment - AccountForecastPeriodMetric - AccountParticipant - AccountPartner - AccountProductForecast - AccountProductPeriodForecast - AccountRelationship - AccountTeamMember - Accreditation - AcctMgrPeriodicTargetDstr - AcctMgrTarget - AcctMgrTargetDstr - ActionCadence - ActionCadenceStep - ActionCadenceTracker - ActionCadenceStepTracker - ActionPlan - ActionPlanItem - ActionPlanItemDependency - ActionPlanTemplate - ActionPlanTemplateItem - ActionPlanTemplateItemValue - ActionPlanTemplateVersion - ActionPlnTmplItmDependency - ActionPlanTmplItmAssessmentInd - ActionVisibility - ActivationTarget - ActiveScratchOrg - ActivityMetric - ActivityTiming - AddOnDefinition - Address - AdCreativeSizeType - AdOrderItem - AdOrderLineAdTarget - AdPageLayoutType - AdProductTargetCategory - AdQuote - AdServer - AdServerAccount - AdServerUser - AdSpaceCreativeSizeType - AdSpaceGroupMember - AdSpaceSpecification - AdTargetCategory - AdTargetCategorySegment - AdUsage - AdUsageSummary - AdvAccountForecastFact - AdvAcctForecastSetPartner - AiDataset - AiImageDetectedObject - AiImageTrainingObject - AiVisionModel - AiVisionModelMetric - AiVisionModelObjectMetric - AiVisitRecommendRequest - AiVisitRecommendation - AiVisitSummary - AiVisitTaskRcmd - AiVisitTaskRcmdRequest - AirTravelEmssnFctr - AirTravelEnrgyUse - AllergyIntolerance - AlternativePaymentMethod - ApiAnomalyEventStore - AppAnalyticsQueryRequest - AppExtension - AppMenuItem - AppUsageAssignment - ApplicationCase - ApplicationFormTemplate - AppointmentInvitation - AppointmentInvitee - AppointmentReason - AppointmentTopicTimeSlot - ApptBundleAggrDurDnscale - ApptBundleAggrPolicy - ApptBundleConfig - ApptBundlePolicy - ApptBundlePolicySvcTerr - ApptBundlePropagatePolicy - ApptBundleRestrictPolicy - ApptBundleSortPolicy - Assessment - AssessmentIndDefinedValue - AssessmentIndValue - AssessmentIndicatorDefinition - AssessmentQuestion - AssessmentQuestionResponse - AssessmentQuestionSet - AssessmentQuestionVersion - AssessmentTask - AssessmentTaskContentDocument - AssessmentTaskDefinition - AssessmentTaskIndDefinition - AssessmentTaskOrder - Asset - AssetAction - AssetActionSource - AssetAttribute - AssetDowntimePeriod - AssetRelationship - AssetStatePeriod - AssetWarranty - AssignedResource - AssistantText - AssociatedLocation - Assortment - AssortmentProduct - AsyncOperationLog - AttachedContentNote - AttributeCategory - AttributeDefinition - AttributePicklist - AttributePicklistValue - AuthApplicationAsset - AuthApplicationPlace - AuthFormRequestRecord - AuthLocationAccessSchedule - AuthorNote - AuthorizationForm - AuthorizationFormConsent - AuthorizationFormDataUse - AuthorizationFormText - AuthorizedInsuranceLine - AuthProvider - AutomatedAction - AutomatedActionCondition - AutomatedActionParameter - Award - BCEntityPermission - BCEntityPermissionSet - BCFieldPermission - BCParticipant - BCParticipantAccess - BCPermissionSet - BCRecordAccess - BCRecordAccessApproval - BCRelatedParticipant - BackgroundOperation - Banker - BatchJob - BatchJobDefinition - BatchJobPart - BatchJobPartFailedRecord - Benefit - BenefitParameterValue - BenefitSchedule - BenefitSession - BenefitType - BillingBatchFilterCriteria - BillingBatchScheduler - BillingPeriodItem - BillingPeriodTaxItem - BillingPolicy - BillingSchedule - BillingScheduleCreationStatus - BillingScheduleGroup - BillingTreatment - BillingTreatmentItem - BldgEnrgyIntensity - BldgEnrgyIntensityVal - BldgSizeCategory - BlockchainAppMember - BlockchainApplication - BlockchainEntity - BlockchainField - BlockchainMember - BoardCertification - BranchUnit - BranchUnitBusinessMember - BranchUnitCustomer - BranchUnitRelatedRecord - BroadcastCommunication - Budget - BudgetAllocation - BundledCareFeeAgreement - BusRegAuthTypeDependency - BusRegAuthorizationType - BusinessBrand - BusinessHours - BusinessLicense - BusinessLicenseApplication - BusinessMilestone - BusinessProfile - BusinessType - BuyerAccount - BuyerGroupPricebook - CalcProcStepRelationship - CalculationMatrix - CalculationMatrixColumn - CalculationMatrixRow - CalculationMatrixVersion - CalculationProcedure - CalculationProcedureStep - CalculationProcedureVariable - CalculationProcedureVersion - Campaign - CampaignInfluence - CampaignInsight - CampaignMember - CampaignMemberStatus - CapitationCareFeeAgreement - CardPaymentMethod - CareBarrier - CareBarrierDeterminant - CareBarrierType - CareBenefitVerifyRequest - CareDeterminant - CareDeterminantType - CareDiagnosis - CareFeeScheduleItem - CareInterventionType - CareLimitType - CareMetricTarget - CareObservation - CareObservationComponent - CarePlanDetail - CarePerformer - CarePgmProvHealthcareProvider - CarePractnFacilityAppt - CarePreauth - CarePreauthItem - CareProgram - CareProgramCampaign - CareProgramEligibilityRule - CareProgramEnrollee - CareProgramEnrolleeProduct - CareProgramEnrollmentCard - CareProgramGoal - CareProgramProduct - CareProgramProvider - CareProgramTeamMember - CareProviderAdverseAction - CareProviderFacilitySpecialty - CareProviderSearchableField - CareRegisteredDevice - CareRequest - CareRequestDrug - CareRequestExtension - CareRequestItem - CareRequestReviewer - CareSpecialty - CareSpecialtyTaxonomy - CareTaxonomy - CartDeliveryGroup - CartItem - CartItemPriceAdjustment - CartTax - Case - CaseArticle—See [Salesforce Knowledge Developer Guide](https://developer.salesforce.com/docs/atlas.en-us.264.0.knowledge_dev.meta/knowledge_dev/knowledge_development_uiapi_limitations.htm) for UI API limitations. - CaseContactRole - CaseMilestone - CaseParticipant - CaseRelatedFile - CaseRelatedIssue - CaseServicePlan - CategorizedCareFeeAgreement - ChangeRequest - ChangeRequestRelatedIssue - ChannelObjectLinkingRule - ChannelProgram - ChannelProgramLevel - ChannelProgramMember - Claim - ClaimCase - ClaimCovPaymentAdjustment - ClaimCovReserveAdjustment - ClaimCoverage - ClaimCoveragePaymentDetail - ClaimCoverageReserveDetail - ClaimItem - ClaimParticipant - ClaimPaymentSummary - ClaimRecovery - ClinicalAlert - ClinicalEncounter - ClinicalEncounterDiagnosis - ClinicalEncounterFacility - ClinicalEncounterIdentifier - ClinicalEncounterProvider - ClinicalEncounterReason - ClinicalEncounterSvcRequest - ClinicalServiceRequest - ClinicalServiceRequestDetail - CloudServiceProvider - CodeSet - CodeSetBundle - CommSubscription - CommSubscriptionChannelType - CommSubscriptionConsent - CommSubscriptionTiming - CommissionSchedule - CommissionScheduleAssignment - ComplaintCase - ComplaintParticipant - ConsentMetric - ConsentUsageMetric - ConsumptionRate - ConsumptionSchedule - Contact - ContactEncounter - ContactEncounterParticipant - ContactPointAddress - ContactPointConsent - ContactPointEmail - ContactPointPhone - ContactPointTypeConsent - ContactRequest - ContentDocument - ContentDocumentLink - ContentDocumentListViewMapping - ContentFolderItem - ContentFolderLink - ContentNote - ContentVersion - ContentWorkspace - Contract - ContractContactRole - ContractDocVerContentDoc - ContractDocVersionSection - ContractDocumentVersion - ContractGroupPlan - ContractGroupPlanGroupClass - ContractLineItem - ContractPaymentAgreement - ContractType - ContractTypeConfig - ConversationBroadcast - ConversationBroadcastEntry - Coupon - CourseOffering - CourtAction - CourtActionOutcome - CoverageBenefit - CoverageBenefitItem - CoverageBenefitItemLimit - CoverageType - CrbnEmssnScopeAlloc - CrbnEmssnScopeAllocVal - CredentialStuffingEventStore - CreditMemo - CreditMemoInvApplication - CreditMemoLine - Crisis - CryptoTransEnvelopeChgLog - CspTrustedSites - Customer - CustomerProperty - CustomObjectParticipant - CustomPermission - DandBCompany - DataAction - DataActionTarget - DataConnectorS3 - DataLakeObjectInstance - DataStream - DataUseLegalBasis - DataUsePurpose - DelegatedAccount - DeleteEvent - DeliveryTask - DiagnosticSummary - DiagnosticSummaryDetail - DigitalSignature - DigitalWallet - DistributorAuthorization - DocTemplateSectionCondition - DocumentChecklistItem - DocumentEnvelope - DocumentGenerationSetting - DocumentRecipient - DocumentTemplate - DocumentTemplateClause - DocumentTemplateContentDoc - DocumentTemplateSection - DocumentTemplateToken - DsarPolicyLog - DuplicateRecordItem - DuplicateRecordSet - DynamicDataCapture - ECart - EditionDefinition - ElectricityEmssnFctrSet - ElectronicMediaGroup - EmailMessage - EmailTemplate - Employee - EmployeeAsset - EmployeeContact - EmployeeCrisisAssessment - EmployeeJob - EmployeeJobPosition - EmployeeOrganization - EmpUserProvisioningProcess - EmpUserProvisionProcessErr - EnablementMeasureDefinition - EnablementProgram - EndCaseArticle - EngagementChannelType - EnhancedLetterhead - EnrolleeBenefit - EnrollmentEligibilityCriteria - Entitlement - EntitlementContact - EntityArchivingException - EntityArchivingJob - EntityArchivingSetup - EntityMilestone - EnvironmentHubMember - Event - Examination - Expense - ExpenseReport - ExpenseReportEntry - ExplainabilityMsgTemplate - ExpressionSetView - ExternalAccountHierarchy - ExtDataShare - ExtDataShareTarget - FeedItem - FeeScheduleDefinition - FieldPermissions - FieldServiceMobileExtension - FieldServiceMobileSettings - FieldServiceOrgSettings - FinanceBalanceSnapshot - FinanceBook - FinancePeriod - FinanceTransaction - FinanceTransactionErrorLog - FinancialDeal - FinancialDealAsset - FinancialDealBid - FinancialDealInteraction - FinancialDealParticipant - FinancialDealParty - FinancialDealProduct - FinclDealInteractionSummary - FlowInterview - FlowOrchestrationInstance - FlowOrchestrationLog - FlowOrchestrationStageInstance - FlowOrchestrationStepInstance - FlowOrchestrationWorkItem - ForecastingCustomData - ForecastingFact - ForecastingOwnerAdjustment - ForecastingQuota - ForecastingType - FrgtHaulingEmssnFctr - FrgtHaulingEnrgyUse - FtestConcrete - FtestConcrete6 - FtestConcrete7 - FtestConcrete8 - FtestZosUiPrototypeChild1 - FtestZosUiPrototypeChild2 - FtestZosUiPrototypeParent - FulfillmentOrder - FulfillmentOrderLineItem - GeneratedDocument - GeneratedDocumentSection - GeneratedWaste - GenericVisitTask - GenericVisitTaskContext - GeoCountry - GeoState - GnrcVstKeyPerformanceInd - GnrcVstTaskContextRelation - GoalDefinition - GoalLink - GroundTravelEmssnFctr - GroundTravelEnrgyUse - Group - GroupCensus - GroupCensusMember - GroupClass - GroupClassContribution - GroupMember - GuestBuyerProfile - HealthCareDiagnosis - HealthCareProcedure - HealthCondition - HealthConditionDetail - HealthcareFacility - HealthcareFacilityNetwork - HealthcarePayerNetwork - HealthcarePractitionerFacility - HealthcareProvider - HealthcareProviderNpi - HealthcareProviderSpecialty - HealthcareProviderTaxonomy - Holiday - HotelStayEmssnFctr - HotelStayEnrgyUse - IPAddressRange - Identifier - IdentityDocument - Image - Incident - IncludedLicenseDefinition - Individual - IndividualApplication - IndividualCrisisAssessment - InflationRate - InfoAuthRequestForm - InfoAuthorizationRequest - InsightsExternalData - InsightsExternalDataPart - InspectionAssessmentInd - InspectionType - InStoreLocation - InsuranceClaimAsset - InsuranceContract - InsurancePolicy - InsurancePolicyAsset - InsurancePolicyCoverage - InsurancePolicyMemberAsset - InsurancePolicyParticipant - InsurancePolicySurcharge - InsurancePolicyTransaction - InsuranceProfile - IntegrationProviderDef - Interaction - InteractionAttendee - InteractionParticipant - InteractionSumDiscussedAccount - InteractionSummary - InteractionSummaryParticipant - InterestTag - InternalOrganizationUnit - InventoryItemReservation - InventoryReservation - Invoice - InvoiceAddressGroup - InvoiceLine - JobFamily - JobPosition - JobProfile - JobRole - JournalReason - JournalSubType - JournalType - KnowledgeArticleVersion—See [Salesforce Knowledge Developer Guide](https://developer.salesforce.com/docs/atlas.en-us.264.0.knowledge_dev.meta/knowledge_dev/knowledge_development_uiapi_limitations.htm) for UI API limitations. - Lead - LeadLineItemLeadPreferredSeller - LearningItem - LearningItemAssignment - LearningItemProgress - LegalEntity - LicensingError - LicensingRequest - LicensingRequestOrderItem - LicensingSnapshotRequest - LinkedArticle—See [Salesforce Knowledge Developer Guide](https://developer.salesforce.com/docs/atlas.en-us.264.0.knowledge_dev.meta/knowledge_dev/knowledge_development_uiapi_limitations.htm) for UI API limitations. - ListEmail - LiveAgentSession - LiveChatSensitiveDataRule - LiveChatTranscript - LiveChatVisitor - LoanApplicant - LoanApplicantAddress - LoanApplicantAsset - LoanApplicantDeclaration - LoanApplicantEmployment - LoanApplicantIncome - LoanApplicantLiability - LoanApplicationAsset - LoanApplicationFinancial - LoanApplicationLiability - LoanApplicationProperty - LoanApplicationTitleHolder - LocWaitlistMsgTemplate - Location - LocationGroupAssignment - LocationTrustMeasure - LocationWaitlist - LocationWaitlistedParty - LoyaltyAggrPointExprtLedger - LoyaltyLedger - LoyaltyMemberCurrency - LoyaltyMemberTier - LoyaltyPartnerProduct - LoyaltyPgmGroupMbrRlnsp - LoyaltyPgmMbrAttributeVal - LoyaltyPgmPartnerCurrency - LoyaltyPgmPartnerPromotion - LoyaltyPgmPtnrLdgrSummary - LoyaltyPgmPtnrPrepaidPack - LoyaltyProgram - LoyaltyProgramCurrency - LoyaltyProgramMbrPromotion - LoyaltyProgramMember - LoyaltyProgramMemberCase - LoyaltyProgramPartner - LoyaltyProgramPartnerLedger - LoyaltyProgramProcess - LoyaltyProgramProcessRule - LoyaltyTier - LoyaltyTierBenefit - LoyaltyTierGroup - Macro - ManufacturingProgram - MaintenanceAsset - MaintenancePlan - MaintenanceWorkRule - ManagedContent - ManagedContentVariant - MarketSegmentActivation - MarketingAction - MarketingAppExtAction - MarketingAppExtActivity - MarketingAppExtAssignment - MarketingAppExtension - MarketingForm - MarketingLink - MarketingLinkContent - MarketingResource - MediaChannel - MediaContentTitle - Medication - MedicationDispense - MedicationReconciliation - MedicationRequest - MedicationStatement - MedicationStatementDetail - MedicinalIngredient - MedReconRecommendation - MedReconStmtRecommendation - MemberBenefit - MemberPlan - MessagingChannel - MessagingDeliveryError - MessagingEndUser - MessagingSession - Metric - MilestoneType - MktCalculatedInsight - MktDataTransform - MktMLModel - MobileSettingsAssignment - MsgChannelLanguageKeyword - MultipartyInfoAuthRequest - NamespaceRegistry - Network - NetworkReferencedObject - Note - ObjectPermissions - ObjectStateDefinition - ObjectStateTransition - ObjectStateValue - OcrDocumentScanResult - OmniDataPack - OmniDataTransform - OmniDataTransformItem - OmniESignatureTemplate - OmniInteractionConfig - OmniProcess - OmniProcessAsmtQuestionVer - OmniProcessCompilation - OmniProcessElement - OmniProcessTransientData - OmniScriptSavedSession - OmniUiCard - OperatingHours - OperatingHoursHoliday - Opportunity - OpportunityContactRole - OpportunityHistory - OpportunityLineItem - OpportunityLineItemSplit - OpptyLineItemSplitType - OpportunityLineItemSchedule - OpportunityParticipant - OpportunityPartner - OpportunityPreferredSeller - OpportunitySplit - OpportunityTeamMember - Order - OrderAction - OrderAdjustmentGroup - OrderChangeLog - OrderDeliveryGroup - OrderDeliveryMethod - OrderItem - OrderItemAdjustmentLineItem - OrderItemRelationship - OrderItemRelationshipChangeEvent - OrderItemRelationshipFeed - OrderItemRelationshipHistory - OrderItemRelationshipShare - OrderItemSummaryChange - OrderItemTaxLineItem - OrderItemTaxLineItemSummary - OrderSummary - OrderSummaryRoutingSchedule - OrgMetric - OrgMetricScanResult - OrgMetricScanSummary - Organization - OtherComponentTask - OtherEmssnFctrSet - OtherEmssnFctrSetItem - ParticipantRole - Partner - PartnerFundAllocation - PartnerFundClaim - PartnerFundRequest - PartnerMarketingBudget - PartyConsent - PartyIncome - PatientHealthReaction - PatientImmunization - PatientMedicalProcedure - PatientMedicalProcedureDetail - PatientMedicationDosage - Payment - PaymentApplicationMethod - PaymentAuthorization - PaymentAuthAdjustment - PaymentBatchRun - PaymentBatchRunCriteria - PaymentGateway - PaymentGatewayLog - PaymentGatewayProvider - PaymentIntent - PaymentLineInvoice - PaymentPolicy - PaymentRequest - PaymentRequestLine - PaymentSchedule - PaymentScheduleItem - PaymentTreatment - PcmtEmssnFctrSet - PcmtEmssnFctrSetItem - PercentileBsdCareFeeAgreement - PermissionSet - PermissionSetGroup - PermissionSetLicense - PersonAccount - PersonEducation - PersonEmployment - PersonExamination - PersonLanguage - PersonLifeEvent - PersonName - PersonTraining - PersonalDevelopmentPlan - PersonalDevelopmentPlanItem - PgmRebateTypBnftMapping - PlanBenefit - PlanBenefitItem - PlatformLicenseDefinition - Polygon - PreliminaryApplicationRef - PreventiveCareAgreement - PriceAdjustmentGroupShape - PriceAdjustmentItemShape - PriceAdjustmentSchedule - PriceAdjustmentTier - Pricebook2 - PricebookEntry - PriceRule - PriceRuleAction - PriceRuleActionItem - PriceRuleCondition - PriceRuleConditionFilter - PriceRuleExecutionStage - PrivacyJobSession - PrivacyPolicy - PrivacyRequest - Problem - ProblemIncident - ProcessDefinition - ProcessException - ProcessInstance - Producer - ProducerCommission - ProducerPolicyAssignment - Product2 - Product2DataTranslation - ProductAttribute - ProductAttributeDefinition - ProductAttributeSet - ProductAttributeSetItem - ProductAttributeSetProduct - ProductAvailabilityProjection - ProductCatalog - ProductCategory - ProductCategoryAttribute - ProductCategoryDataTranslation - ProductCategoryMedia - ProductCategoryProduct - ProductComponentGroup - ProductConsumed - ProductConsumedState - ProductConsumptionSchedule - ProductCoverage - ProductEmissionsFactor - ProductFulfillmentLocation - ProductItem - ProductItemTransaction - ProductLicenseMap - ProductMedia - ProductQuantityRule - ProductRelatedComponent - ProductRelationshipType - ProductRequest - ProductRequestLineItem - ProductRequired - ProductSellingModel - ProductSellingModelOption - ProductServiceCampaign - ProductServiceCampaignItem - ProductSpecificationType - ProductTaxPolicy - ProductTransfer - ProductTransferState - ProductWarrantyTerm - Profile - ProfileSkill - ProfileSkillEndorsement - ProfileSkillUser - ProgramRebateTypPayoutSrc - ProgramRebateType - ProgramRebateTypeBenefit - ProgramRebateTypeFilter - ProgramRebateTypePayout - ProgramRebateTypeProduct - ProgramRebateTypeReference - Promotion - PromotionChannel - PromotionDataTranslation - PromotionLoyaltyPtnrProdt - PromotionMarketSegment - PromotionProduct - PromotionProductCategory - PromotionQualifier - PromotionSegment - PromotionSegmentBuyerGroup - PromotionSegmentSalesStore - PromotionTarget - ProrationPolicy - ProviderNetworkTier - ProviderSearchSyncLog - ProvisioningRun - ProvisioningRunEvent - ProvisioningTargetGroup - ProvisioningTargetItem - ProvisioningTargetRole - PublicApplicationParticipant - PublicComplaint - PublicProgram - PublicServiceGoal - PurchaseQuantityRule - PurchaserPlan - PurchaserPlanAssn - QuickText - Quote - QuoteDocument - QuoteItemTaxItem - QuoteLineItem - QuoteLineItemAttribute - QuoteLinePriceAdjustment - RebateMemberAggregateItem - RebateMemberProductAggregate - RebatePayment - RebatePayoutAdjustment - RebateProgram - RebateProgramMember - RebateProgramMemberPayout - RebateProgramPayoutPeriod - ReceivedDocument - ReceivedDocumentType - Recommendation - RecordAction - RecordAlert - RecordType - RecordsetFilterCriteria - RecordsetFilterCriteriaRule - RefrigerantEmssnFctr - RefundLinePayment - RegAuthorizationTypeProduct - RegulatoryAuthority - RegulatoryAuthorizationType - RegulatoryCode - RegulatoryCodeAssessmentInd - RegulatoryCodeViolation - RegulatoryTrxnFee - RegulatoryTrxnFeeItem - RentalCarEmssnFctr - RentalCarEnrgyUse - ReplyText - ReportAnomalyEventStore - ResidentialLoanApplication - ResourceAbsence - ResourcePreference - RetailLocationGroup - RetailStore - RetailStoreGroupAssignment - RetailStoreKpi - RetailVisitKpi - ReturnOrder - ReturnOrderLineItem - RevRecogTreatmentItemGroup - RevenueDistributionMethod - RevenueElement - RevenueElementDistribution - RevenueRecogTreatmentItem - RevenueRecognitionPolicy - RevenueRecognitionTreatment - RevenueTransactionErrorLog - SalesAgreement - SalesAgreementProduct - SalesAgreementProductSchedule - SalesContractLine - SalesforceContract - SalesforceInvoice - SalesforceQuote - SalesTransactionItemShape - SalesTransactionShape - SalesTrxnItemRelationship - SchedulingConstraint - Scope3CrbnFtprnt - Scope3EmssnSrc - Scope3PcmtItem - Scope3PcmtSummary - Scorecard - ScorecardAssociation - ScorecardMetric - SearchPromotionRule - SecuritiesHolding - Seller - SerializedProduct - SerializedProductTransaction - ServiceAppointment - ServiceAppointmentCapacityUsage - ServiceAppointmentStatus - ServiceContract - ServiceCrew - ServiceCrewMember - ServicePlanTemplate - ServicePlanTemplateBenefit - ServicePlanTemplateGoal - ServiceReport - ServiceReportLayout - ServiceResource - ServiceResourceCapacity - ServiceResourcePreference - ServiceResourceSkill - ServiceTerritory - ServiceTerritoryLocation - ServiceTerritoryMember - ServiceTerritoryWorkType - SessionHijackingEventStore - SettingUsageDefinition - SettingUsageMap - SetupAssistantStep - SharedSavingPaymentAgreement - SharingRecordCollection - SharingRecordCollectionItem - Shift - ShiftPattern - ShiftPatternEntry - ShiftTemplate - Shipment - SignatureTask - SignatureTaskLineItem - Skill - SkillLevelDefinition - SkillRequirement - Snippet - SocialPersona - SocialPost - StandardCareFeeAgreement - StandardPermissionSet - StaticResource - StnryAssetCrbnFtprnt - StnryAssetCrbnFtprntItm - StnryAssetEnrgyUse - StnryAssetEnvrSrc - StnryAssetWaterActvty - StnryAssetWaterFtprnt - StoreActionPlanTemplate - StoreAssortment - StoreIntegratedService - StoreProduct - StreamingChannel - Survey - SurveyEmailBranding - SurveyInvitation - SurveyQuestion - SurveyQuestionChoice - SurveyQuestionResponse - SurveyResponse - SurveySubject - SurveyVersion - SvcCatalogCategory - SvcCatalogCategoryItem - SvcCatalogCategoryItemDef - SvcCatalogReqRelatedItem - Swarm - SwarmMember - TagCategory - TagCategoryAssignment - Task - TaxEngine - TaxEngineInteractionLog - TaxEngineProvider - TaxPolicy - TaxTreatment - TaxRate - Tenant - TenantParameterMap - TenantSecurityNotificationRule - Territory2 - ThreatDetectionFeedback - TimeSheet - TimeSheetEntry - TimeSlot - TimelineObjectDefinition - Topic - TopicAssignment - TrainingCourseParticipant - TransactionJournal - Translation - TravelMode - TrialEnvironmentSignup - TrnCourse - UnitOfMeasure - UnitOfMeasureConversion - UsageEntitlement - UsageEntitlementPeriod - UsageEntitlementUsage - UsageFactor - User - UserAccessPolicy - UserAppMenuItem - UserDefinedLabel - UserDefinedLabelAssignment - UserEsignVendorIdentifier - UserLicenseDefinition - UserRole - UserTerritory2AssocLog - UserUiPreference - VehicleAssetCrbnFtprnt - VehicleAssetEmssnSrc - VehicleAssetEnrgyUse - VehicleUserAssignment - VideoCall - VideoCallParticipant - VideoRecording - ViolationEnforcementAction - ViolationType - ViolationTypeAssessmentInd - Visit - VisitedParty - Visitor - VoiceCall - VolunteerProject - Voucher - VoucherDefinition - WarrantyTerm - WasteFootprint - WasteFootprintItem - WaveAutoInstallRequest - WebCart - WebStore - WebStoreBuyerGroup - WebStoreCatalog - WebStorePricebook - WebStoreSearchProdSettings - WorkCapacityLimit - WorkCapacityUsage - WorkCoaching - WorkContract - WorkforceCapacity - WorkforceCapacityPlan - WorkOrder - WorkOrderLineItem - WorkPlan - WorkPlanSelectionRule - WorkPlanTemplate - WorkPlanTemplateEntry - WorkRewardFund - WorkRewardFundType - WorkStep - WorkStepStatus - WorkStepTemplate - WorkType - WorkTypeCareSpecialty - WorkTypeCodeSetBundle - WorkTypeGroup - WorkTypeGroupMember - WorkerCompCoverageClass - WstDispoEmssnFctrSet - WstDispoEmssnFctrSetItm # API End-of-Life Policy Salesforce is committed to supporting each API version for a minimum of three years from the date of first release. To mature and improve the quality and performance of the API, versions that are more than three years old sometimes are no longer supported. Salesforce notifies customers who use an API version scheduled for deprecation at least one year before support for the version ends. | Salesforce API Versions | Version Support Status | Version Retirement Info | | --- | --- | --- | | Versions 31.0 through 68.0 | Supported. | [Salesforce Platform API Versions 31.0 through 40.0 Retirement](https://help.salesforce.com/s/articleView?id=005321531&type=1&language=en_US) | | Versions 21.0 through 30.0 | As of Summer ’25, these versions are retired and unavailable. | [Salesforce Platform API Versions 21.0 through 30.0 Retirement](https://help.salesforce.com/s/articleView?id=000389618&type=1&language=en_US) | | Versions 7.0 through 20.0 | As of Summer ’22, these versions are retired and unavailable. | [Salesforce Platform API Versions 7.0 through 20.0 Retirement](https://help.salesforce.com/s/articleView?id=000380623&type=1&language=en_US) | If you request any resource or use an operation from a retired API version, REST API returns the 410:GONE error code. To identify requests made from old or unsupported API versions, use the [API Total Usage](https://developer.salesforce.com/docs/atlas.en-us.264.0.object_reference.meta/object_reference/sforce_api_objects_eventlogfile_apitotalusage.htm) event type. # App The metadata for a single app.
Property Name Type Description Filter Group and Version Available Version
appId String The unique ID of the app. Small, 43.0 43.0
description String A description of the app. Small, 43.0 43.0
developerName String The API name of the app. Small, 43.0 43.0
formFactors String[] The form factor of the app. One or more of these values:
  • Large—App supports the desktop display size.
  • Medium—App supports the tablet display size.
  • Small—App supports the phone display size.
Medium, 43.0 43.0
headerColor String The primary color for the app as selected by an admin. For example, #0070D2. Small, 43.0 43.0
iconUrl String The URL for the app’s icon. Small, 43.0 43.0
isNavAutoTempTabsDisabled Boolean If true, the navigation automatically creates temporary tabs settings. Small, 43.0 43.0
isNavPersonalizationDisabled Boolean If true, navigation personalization is disabled. Small, 43.0 43.0
isNavTabPersistenceDisabled Boolean If true, workspace tabs are cleared for each new console session. Small, 54.0 54.0
isOmniPinnedViewEnabled Boolean If true, the Omni-Channel sidebar is enabled. Small, 60.0 60.0
label String The label of the app. Small, 43.0 43.0
logoUrl String The logo URL of the app as selected by the admin. Medium, 43.0 43.0
mobileStartUrl String The mobile launch URL for the app. This field is used with client apps and Experience Builder sites. For sites only, this location is a fully qualified domain name. For other apps, it’s a relative URL. Medium, 43.0 43.0
navItems Navigation Item[] The metadata for the navigation tabs of the app.
Note

Note

Only navItems with supported formFactors values are returned.

Big, 43.0 43.0
selected Boolean If true, this app is the default app for the user. Big, 43.0 43.0
startUrl String The launch URL of the app. Medium, 43.0 43.0
type String The type of the app. One of these values:
  • Classic
  • Community
  • Connected
  • ExternalClient
  • Lightning
  • Multiframework
Small, 47.0 47.0
uiType String The UI type for the app. One of these values:
  • Salesforce Classic
  • Lightning Experience

This property was deprecated in API version 47.0. In API version 47.0 and later, use type instead.

Small, 43.0–46.0 43.0–46.0
userNavItems Navigation Item[] The user's navigation tabs for the app. Big, 43.0 43.0
#### See Also - [Apps](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_apps.htm "A list of apps that the current user has access to.") - [Get an App](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps_id.htm "Get the metadata for an app.") - [Get Last Selected App](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps_selected.htm "Retrieves the app the current user last selected or the app the user sees by default.") - [Manage Apps](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_features_apps.htm "An app is a collection of items that work together to serve a particular function. Salesforce apps come in two flavors: Classic apps and Lightning apps. Classic apps are created and managed in Salesforce Classic. Lightning apps are created and managed in Lightning Experience. Admins customize both types of apps to match the way users work.") # Apps Use these resources to get data and metadata for apps displayed in the Salesforce UI. - **[Get Apps](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps.htm)** Get metadata for all the apps a user has access to. Metadata for the selected app includes tabs on the app’s navigation bar. Metadata for other apps doesn’t include tabs on the navigation bar. - **[Get an App](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps_id.htm)** Get the metadata for an app. - **[Update Last Selected App](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps_id_update.htm)** Returns metadata for an app, and saves an app as the last selected for a user. - **[Get Last Selected App](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps_selected.htm)** Retrieves the app the current user last selected or the app the user sees by default. - **[Get Personalized Navigation Items](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps_user_nav_items.htm)** Get a user’s personalized navigation items (tabs). - **[Get All Navigation Items](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_all_nav_items.htm)** Gets all navigation items (tabs) that the user has access to. - **[Update Personalized Navigation Items](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps_update_nav_items.htm)** Updates the order of a user’s personalized navigation items (tabs) and adds a navigation item to the list in the order specified. # Apps A list of apps that the current user has access to. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | apps | [App](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_app.htm#ui_api_responses_app "The metadata for a single app.")\[\] | Metadata for an app. | Small, 43.0 | 43.0 | #### See Also - [Get Apps](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_apps.htm "Get metadata for all the apps a user has access to. Metadata for the selected app includes tabs on the app’s navigation bar. Metadata for other apps doesn’t include tabs on the navigation bar.") - [App](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_app.htm "The metadata for a single app.") - [Manage Apps](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_features_apps.htm "An app is a collection of items that work together to serve a particular function. Salesforce apps come in two flavors: Classic apps and Lightning apps. Classic apps are created and managed in Salesforce Classic. Lightning apps are created and managed in Lightning Experience. Admins customize both types of apps to match the way users work.") # Authentication, Versioning, Limits, ETag, and More Learn the high-level facts about how to use User Interface API. How do you authenticate? How is the API versioned? What are the rate limits? All the information you need, available at a glance. Authentication Like other Salesforce REST APIs, User Interface API uses OAuth 2.0. To specify OAuth settings, create an [external client app](https://help.salesforce.com/s/articleView?id=xcloud.create_a_local_external_client_app.htm&type=5&language=en_US "HTML (New Window)") in Salesforce. Case Sensitivity When writing a User Interface API client, assume case sensitivity. Some parts of the API aren’t case-sensitive, but some are, so it’s best to assume case sensitivity. Dates Dates are represented in [ISO 8601](https://www.w3.org/TR/NOTE-datetime "HTML (New Window)") format. Experience Cloud Site User Access Users with a Customer Community or Partner Community [User License](https://help.salesforce.com/articleView?id=users_license_types_communities.htm&type=0&language=en_US "HTML (New Window)") can access User Interface API. Lightning components on Experience Cloud site pages request UI API resources in the context of a site user. Even if an Experience Cloud site user doesn't have the API Enabled permission, these requests can count towards Salesforce API limits. For example, if you add the component to an Experience Cloud site page, requests from that component to UI API resources are made in the context of a site user. These requests can count towards API limits, even if the user doesn't have the API Enabled permission. HTTP Caching with ETag [Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_record.htm "The field data, API name, child relationship data, and record type information for a record.") responses include a weakEtag property that you can use to compare whether a record is a newer, older, or the same as a record in a previous response. In addition, to take advantage of browser caching, User Interface API responses include an [ETag](https://tools.ietf.org/html/rfc7232#section-2.3 "HTML (New Window)") field. To reduce network traffic and increase your app’s response time, make conditional HTTP requests. If the browser cache holds the latest version of a representation, the web server returns only HTTP headers. The ETag (or Entity Tag) contains a hash that identifies a representation: ETag: "b9a5cd4fbfcf1b65b03d95a4d9ffa8f4--gzip". When a representation changes, the web server generates a new ETag. GET /ui-api/object-info/account HTTP/1.1 200 OK Date: Tue, 07 Nov 2017 04:27:43 GMT Strict-Transport-Security: max-age=31536000; includeSubDomains X-Content-Type-Options: nosniff X-XSS-Protection: 1; mode=block Content-Security-Policy: upgrade-insecure-requests X-Robots-Tag: none Cache-Control: no-cache,must-revalidate,max-age=0,no-store,private Set-Cookie: BrowserId=GHrCS0saRl64DgVv-NrLjA;Path=/;Domain=.salesforce.com;Expires=Sat, 06-Jan-2018 04:27:45 GMT;Max-Age=5184000 Expires: Thu, 01 Jan 1970 00:00:00 GMT **ETag: "b9a5cd4fbfcf1b65b03d95a4d9ffa8f4--gzip"** Content-Type: application/json;charset=UTF-8 Vary: Accept-Encoding Content-Encoding: gzip Transfer-Encoding: chunked { "apiName" : "Account", "childRelationships" : \[ { "childObjectApiName" : "Account", "fieldName" : "ParentId", "junctionIdListNames" : \[ \], "junctionReferenceTo" : \[ \], "relationshipName" : "ChildAccounts" ... response shortened ... \]} ... } The client saves the ETag and sends it in a header in subsequent requests for the resource: If-None-Match: “b9a5cd4fbfcf1b65b03d95a4d9ffa8f4”. The web server compares this ETag value with the ETag value of the current version of the representation. If the values are the same, the browser cache holds the latest version and the web server returns an HTTP status of 304 Not Modified. If-Modified-Since PATCH requests support the [If-Modified-Since](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/If-Modified-Since "HTML (New Window)") HTTP header. Integers We support integers less than 1018. Integers greater than or equal to 231 must be in quotes. JSON Support The JavaScript Object Notation (JSON) format is supported with UTF-8. Limits The User Interface API uses the [Salesforce API limits](https://developer.salesforce.com/docs/atlas.en-us.264.0.salesforce_app_limits_cheatsheet.meta/salesforce_app_limits_cheatsheet/salesforce_app_limits_platform_api.htm "HTML (New Window)") and the [Connect REST API limits](https://developer.salesforce.com/docs/atlas.en-us.264.0.chatterapi.meta/chatterapi/intro_rate_limits.htm "HTML (New Window)"). When you exceed the rate limit, all User Interface API resources return a 503 Service Unavailable error code. Versioning User Interface API is versioned. Specify the API version number in each request. GET https://MyDomainName.my.salesforce.com/services/data/v68.0/ui-api #### See Also - [_Salesforce Help_: Set Up OAuth Flows](https://help.salesforce.com/s/articleView?id=xcloud.external_client_apps_oauth_flow_config.htm&type=5&language=en_US "Salesforce Help: Set Up OAuth Flows - HTML (New Window)") # Batch Operation Input Represents the operation type and record data to create, update, and delete in a batch. JSON example "operations": \[ { "type": "CREATE", "records": \[ { "apiName": "Account", "fields": { "Name": "Global Media" } }, { "apiName": "Contact", "fields": { "LastName": "Smith" } } \] }, { "type": "UPDATE", "records": \[ { "fields": { "Id": "001xx000003Gaf9AAC", "NumberOfEmployees": 1000 } } \] }, { "type": "DELETE", "records": \[ { "fields": { "Id": "001xx000003GanDAAS" } } \] } \] Properties
Name Type Description Required or Optional Available Version
type String The type of record operation. Valid values include: Required 59.0
records Record Input [] A description of a record or multiple records to create, update, and delete. Required 59.0
# Batch Record Input A description of multiple operations for a request to create, update, or delete a batch of records. Example POST /ui-api/records/batch { "allOrNone": false, "operations": \[ { "type": "CREATE", "records": \[ { "apiName": "Account", "fields": { "Name": "ACCOUNT 1" } }, { "apiName": "Contact", "fields": { "LastName": "Smith" } } \] }, { "type": "Update", "records": \[ { "fields": { "Id": "001xx000003Gaf9AAC", "NumberOfEmployees": 1000 } } \] }, { "type": "Delete", "records": \[ { "fields": { "Id": "001xx000003GanDAAS" } } \] } \] } Properties | Name | Type | Description | Required or Optional | Available Version | | --- | --- | --- | --- | --- | | allOrNone | Boolean | Specifies whether to stop processing the request and rollback any changes when the request encounters an error. The default is true. | Optional | 59.0 | | operations | [Batch Operation Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_batch_operation_input.htm "Represents the operation type and record data to create, update, and delete in a batch.") \[\] | A description of records and operation types. | Required | 59.0 | # Batch Result Item The results of one subrequest in a batch request.
Property Type Description Filter Group and Version Available Version
result One of these types: A response body for a record or related list. Small, 41.0 41.0
statusCode Integer An HTTP status code indicating the status of this individual request in the batch. Small, 41.0 41.0
#### See Also - [Batch Results](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_batch_results.htm "The results from a request to a batch resource. Results include information for each subrequest in the batch.") # Batch Results The results from a request to a batch resource. Results include information for each subrequest in the batch. | Property | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | hasErrors | Boolean | true if at least one of the results in the result set is an HTTP status code in the 400 or 500 range; false otherwise | Small, 41.0 | 41.0 | | results | [Batch Result Item](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_batch_result.htm#ui_api_responses_batch_result "The results of one subrequest in a batch request.")\[\] | Collection of batch result items | Small, 41.0 | 41.0 | #### See Also - [Get a Batch of Records](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_batch.htm "Get data for a batch of records.") # Build UI for Picklists User Interface API exposes properties and resources that make it easy for a client to build picklists and dependent picklists. Picklists are complicated UI elements, and dependent picklists are especially tricky. The values in a dependent picklist field are filtered based on the selection in another field, called a controlling field. A controlling field can be a picklist field or a checkbox field. For example, imagine a Continents picklist that controls a Countries picklist that controls a Cities picklist and a Languages picklist field. Dependent picklists exist in a field dependency tree that shows a hierarchy of controlling and dependent fields. Each node in the tree can have any number of child nodes. To build UI, you need to know the complete hierarchy.![Field dependency tree diagram](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/api_ui/images/field_dependency_tree.png) An object can have any number of field dependency trees. User Interface API exposes the collection of field dependency trees in a single property on each object called dependentFields. Each dependent field has a controllingFields property that lists the fields that control it. User Interface API also provides a batch resource to get all picklist values for a record type: [/ui-api/object-info/{objectApiName}/picklist-values/{recordTypeId}](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_picklist_values_collection.htm#ui_api_resources_picklist_values_collection "Use this resource to get the values for all the picklist fields of a specific record type. This resource is especially useful for getting dependent picklist values. For example, if an object has a tree of dependent picklists (Continents__c, Countries__c, Cities__c), use this resource to get all the values for each picklist in one request."). ## Check for Picklists To build UI to create, display, edit, and delete records, make a request to one of the User Interface API resources. The response from each of these resources includes an [Object Info](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_object_info.htm#ui_api_responses_object_info "The metadata for an object.") response body, which contains the object metadata, including information about picklists. - [Get Record Data and Object Metadata](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_ui.htm#ui_api_resources_record_ui "Get layout information, metadata, and data to build UI for a single record or for a collection of records.") - [Get Object Metadata](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_object_info.htm#ui_api_resources_object_info "Get metadata about a specific object. The response includes metadata describing fields, child relationships, record type, and theme.") - [Get Default Values to Create a Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_defaults_create.htm#ui_api_resources_record_defaults_create "Get the default values for fields for a new record of a specified object and optional record type. After getting the default values, make a request to POST /ui-api/records to create the record.") - [Get Default Values to Clone a Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_defaults_clone.htm#ui_api_resources_record_defaults_clone "Get the default layout information, object information, and data for cloning a record. After getting the default values, make a request to POST /ui-api/records to create the record.") 1. Parse the response for each field’s dataType. If the dataType is Picklist or MultiPicklist, the field is a picklist. 2. If you find a picklist, grab the recordTypeId, you’ll use it in a request to get the picklist values. 3. Parse the response for dependent picklists. If the field is a picklist and if the controllingFields property is non-null, the field is a dependent picklist. 4. If the field is a dependent picklist, look at the dependentFields property on the object to see the tree structure of the object’s dependent and controlling fields. A dependent picklist can depend on (be controlled by) standard or and custom picklists and checkboxes. { ... "dependentFields" : { "Continents\_\_c" : { "Countries\_\_c" : { "Cities\_\_c" : { }, "Languages\_\_c" : { }, } } }, ... "fields" : { "AccountSource" : { ... "controllingFields" : \[ \], ... "dataType" : "Picklist", ... }, "Cities\_\_c" : { ... "controllingFields" : \[ "Countries\_\_c", "Continents\_\_c" \], ... "dataType" : "Picklist", ... }, "Continents\_\_c" : { ... "controllingFields" : \[ \], ... "dataType" : "Picklist", ... }, "Countries\_\_c" : { ... "controllingFields" : \[ "Continents\_\_c" \], ... "dataType" : "Picklist", ... }, "Languages\_\_c" : { ... "controllingFields" : \[ "Countries\_\_c", "Continents\_\_c" \], ... "dataType" : "Picklist", ... }, ... "recordTypeInfos" : { "012000000000000AAA" : { ... "recordTypeId" : "012000000000000AAA" } }, ... } Here’s a bit more info about the dependent and controlling fields properties. - {Object}.dependentFields—A map of the dependent fields tree structure. Each nested object is another Map. When the object is empty, it indicates a leaf of the tree, which is a field that doesn’t control other fields. An object can have multiple independent trees, which means this property can have multiple root objects. Imagine an object with the picklists Continents\_\_c, Countries\_\_c, and Cities\_\_c. Continents\_\_c is the root. Cities\_\_c is a leaf. Continents\_\_c and Countries\_\_c are controlling fields. Countries\_\_c and Cities\_\_c are dependent picklists. - {Field}.controllingFields—If this field is a dependent picklist, this property is a collection of fields that control the values in the picklist. When there’s a hierarchy of controlling fields, the collection starts with the immediate parent and moves up the tree. ## Get Picklist Values You know that the object has picklists, you know whether it has dependent picklists, and you know how the dependent picklists are controlled. It’s time to get the picklist values. 1. Do one of the following: - To retrieve the values for all picklists of a record type, make a request to [GET /ui-api/object-info/${objectApiName}/picklist-values/${recordTypeId}](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_picklist_values_collection.htm#ui_api_resources_picklist_values_collection "Use this resource to get the values for all the picklist fields of a specific record type. This resource is especially useful for getting dependent picklist values. For example, if an object has a tree of dependent picklists (Continents__c, Countries__c, Cities__c), use this resource to get all the values for each picklist in one request."). It’s handy to retrieve the values in a batch instead of requesting them for each field. - To get the values for a single picklist, make a request to [GET /ui-api/object-info/{objectApiName}/picklist-values/{recordTypeId}/{fieldApiName}](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_picklist_values.htm#ui_api_resources_picklist_values "If a field’s dataType property is equal to Picklist or MultiPicklist, use this resource to get its values."). 2. Get the values for independent picklists. 1. To determine whether a picklist is independent, look at the {Field}.controllingFields property. If the property is empty, the picklist is independent. ![Tip](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/images/icon_note_tip.png) #### Tip If the controllerValues property is empty, like it is for the AccountSource field in the following example, the field isn’t necessarily independent. If the controlling field is protected by field-level security (FLS), it doesn’t appear in the controllerValues property. 2. To populate a picklist in the UI, use the field’s label and value properties. 3. Get the values for dependent picklists. 1. If a picklist is dependent, its controllerValues property lists the values and indexes of its controlling field (except when the immediate controlling field is protected by FLS). The indexes are used in the validFor property to indicate which controlling field values map to which picklist value. For example, in controllerValues, Italy has index 5. In the values.validFor property, you see that Rome is valid for index 5. 2. To populate a picklist in the UI, use the field’s label and value properties. { "picklistFieldValues" : { "AccountSource" : { "controllerValues" : { }, "defaultValue" : null, "url" : "/services/data/v68.0/ui-api/object-info/account/picklist-values/012000000000000AAA/AccountSource", "values" : \[ { "attributes" : null, "label" : "Advertisement", "validFor" : \[ \], "value" : "Advertisement" }, { "attributes" : null, "label" : "Employee Referral", "validFor" : \[ \], "value" : "Employee Referral" }, ... } "Cities\_\_c" : { "controllerValues" : { "Australia" : 0, "Brazil" : 1, "China" : 2, "Colombia" : 3, "France" : 4, "Italy" : 5, "Mexico" : 6, "New Zealand" : 7, "Nigeria" : 8, "Senegal" : 9, "South Korea" : 10, "US" : 11 }, "defaultValue" : null, "url" : "/services/data/v68.0/ui-api/object-info/account/picklist-values/012000000000000AAA/Cities\_\_c", "values" : \[ { "attributes" : null, "label" : "Cali", "validFor" : \[ 3 \], "value" : "Cali" }, { "attributes" : null, "label" : "Chicago", "validFor" : \[ 11 \], "value" : "Chicago" }, { "attributes" : null, "label" : "Dakar", "validFor" : \[ 9 \], "value" : "Dakar" }, { "attributes" : null, "label" : "Lagos", "validFor" : \[ 8 \], "value" : "Lagos" }, { "attributes" : null, "label" : "Los Angeles", "validFor" : \[ 11 \], "value" : "Los Angeles" }, { "attributes" : null, "label" : "Oaxaca", "validFor" : \[ 6 \], "value" : "Oaxaca" }, { "attributes" : null, "label" : "Wellington", "validFor" : \[ 7 \], "value" : "Wellington" } \] }, ## Record Viewer Sample App To view sample code that parses a response and displays dependent picklists, check out the [Record Viewer](https://github.com/forcedotcom/RecordViewer "HTML (New Window)") sample app on GitHub. To contribute to the app, fork it and submit a pull request. We love to see what people do with User Interface API. #### See Also - [User Interface API Sample Apps](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_get_started_sample_apps.htm "We’ve built two sample apps that use User Interface API to create, read, update, and delete records. The apps are open-source and available on GitHub.") - [Get Values for a Picklist Field](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_picklist_values.htm "If a field’s dataType property is equal to Picklist or MultiPicklist, use this resource to get its values.") - [Get Values for All Picklist Fields of a Record Type](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_picklist_values_collection.htm "Use this resource to get the values for all the picklist fields of a specific record type. This resource is especially useful for getting dependent picklist values. For example, if an object has a tree of dependent picklists (Continents__c, Countries__c, Cities__c), use this resource to get all the values for each picklist in one request.") # Canvas Layout Component A canvas component on a record page layout.
Property Name Type Description Filter Group and Version Available Version
apiName String The API name of the canvas app. Small, 41.0 41.0
componentType String The value is Canvas. Small, 41.0 41.0
displayLocation String The location in the application where the canvas app is being called from. One of these values:
  • Chatter—The canvas app was called from the Chatter tab.
  • ChatterFeed—The canvas app was called from a Chatter canvas feed item.
  • MobileNav—The canvas app was called from the navigation menu in the Salesforce mobile app.
  • OpenCTI—The canvas app was called from an Open CTI component.
  • PageLayout—The canvas app was called from an element within a page layout. If the displayLocation is PageLayout, one of the subLocation values can be returned.
  • Publisher—The canvas app was called from a canvas custom quick action.
  • ServiceDesk—The canvas app was called from a Salesforce Console component.
  • Visualforce—The canvas app was called from a Visualforce page.
  • None—The canvas app was called from the Canvas App Previewer.

The sublocation in the application where the canvas app was called from when the canvas app is loaded in a mobile device. The possible values are:

  • S1MobileCardFullview—The canvas app was called from a mobile card.
  • S1MobileCardPreview—The canvas app was called from a mobile card preview.
  • S1RecordHomePreview—The canvas app was called from a record detail page preview.
  • S1RecordHomeFullview—The canvas app was called from a page layout.
Small, 41.0 41.0
height String The height of the component. Small, 41.0 41.0
referenceId String The unique ID of the canvas app definition. Small, 41.0 41.0
showScroll Boolean Indicates whether to show the scroll bar on the canvas component (true) or not (false). Small, 41.0 41.0
width String The width of the component. Small, 41.0 41.0
#### See Also - [Record Layout Item](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_record_layout_item.htm "An item in a record layout.") # Case Status Picklist Value Attributes Additional picklist value attributes for case statuses.
Property Name Type Description Filter Group and Version Available Version
closed Boolean If this status indicates the case has been closed, the value is true, otherwise false. Small, 48.0 48.0
picklistAtrributes​ValueType String The value is CaseStatus. Indicates that these value attributes are associated with the status of a case.

For more information, see the CaseStatus object documentation.

The property picklistAtrributes​ValueType contains a typographical error.

Small, 48.0 48.0
#### See Also - [Picklist Value](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_picklist_value.htm "A single picklist value.") # Check for Duplicate Records Before updating or creating a record, you can check whether a duplicate record exists. Use the response to learn whether to block or allow the action, and whether to warn the user. ![Tip](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/images/icon_note_tip.png) #### Tip To learn more about when to check for duplicate records, see [Get Duplicate Management Configuration for a Specified Object](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_duplicates_get.htm "Learn whether duplicate management is configured for the specified object. If duplicate management is configured, learn about the object's duplicate rules and matching rules. Use the information in the response to know when to check for duplicate records."). Resource /ui-api/predupe Available Version 50.0 HTTP Method POST Example Use the following request to check whether a duplicate record for the movie "Aliens" exists. ui-api/predupe{ "apiName" : "Movie\_\_c", "fields" : {"Name": "Aliens", "Year\_\_c": "1986" } Request Body
Name Type Description Required or Optional Available Version
allowSaveOnDuplicate Boolean Specifies whether to save a duplicate record (true), or not (false). The default value is false.

Don’t specify this property when checking for duplicate records.

Optional 43.0
apiName String To create a record, specify the API name of an Object from which to create the record. To update a record, use null or don’t pass this property. To check for duplicate records, specify the API name of the object for which you’re performing the duplicate check. Required to create a record.

Required to check for duplicate records.

41.0
fields Map<String, Object> Map of field names to field values.

Format data types according to these rules:

  • Address—JSON String. Addresses are compound fields and must be broken up into their constituent fields. See the previous example.
  • Boolean—JSON Boolean, true or false
  • Currency—JSON Number (for example, 67.54)
  • Date—JSON string (for example, 2020-04-20)
  • DateTime—JSON string in ISO 8601 format (for example, 2012-02-18T06:40:41.000Z)
  • Double—JSON Number
  • Email—JSON String (for example, joe@smith.com)
  • EncryptedString—JSON String
  • Int—JSON Number
  • Location—JSON String. Location fields are compound fields and must be broken up into their constituent fields.
  • MultiPicklist—JSON String (for example, Dog;Cat;Fish).
  • Percent—JSON Number
  • Phone—JSON String
  • Picklist—JSON String
  • Reference—JSON String
  • String—JSON String
  • TextArea—JSON String
  • Time—JSON String in format HH:MM:SS
  • Url—JSON String

To specify the main record type, either don’t specify the RecordTypeId field, or set it to null.

Required 41.0
Response Body [Duplicates](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_duplicates.htm "The results of a check for duplicate records.") #### See Also - [Get Duplicate Management Configuration for a Specified Object](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_duplicates_get.htm "Learn whether duplicate management is configured for the specified object. If duplicate management is configured, learn about the object's duplicate rules and matching rules. Use the information in the response to know when to check for duplicate records.") # Child Relationship The child relationship on a parent object. Relationships are connections between records. Use relationships to display data about related object records on a record's detail page.
Property Name Type Description Filter Group and Version Available Version
childObjectApiName String The API name of the child object. Medium, 41.0 41.0
fieldName String The field on the child object that contains the reference to the parent object.

Instead of defining relationships through primary keys and foreign keys, the Salesforce database uses reference fields. A reference field stores the ID of the related parent record.

Medium, 41.0 41.0
junctionIdListNames String[] The names of the JunctionIdList fields associated with an object. Each ID is a polymorphic key, which is an ID that can refer to more than one type of object. Medium, 41.0 41.0
junctionReferenceTo String[] A collection of object names that the polymorphic keys in the junctionIdListNames property can reference.

You can query these object names.

Medium, 41.0 41.0
relationshipName String The name of the relationship.

A name for the child relationship that is unique to the parent. The name is the plural form of the child object name. For example, Account has child relationships to Assets, Cases, and Contacts, among other objects. Account has a relationshipName for each object: Assets, Cases, and Contacts.

Medium, 41.0 41.0
#### See Also - [Object Info](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_object_info.htm "The metadata for an object.") # Content Document Composite The file and its relationship to a record. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | contentDocument | [Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_record.htm "The field data, API name, child relationship data, and record type information for a record.") | The record associated with the content document. | Small, 56.0 | 56.0 | | contentDocumentLinks | [Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_record.htm "The field data, API name, child relationship data, and record type information for a record.")\[\] | The relationship between a record and a content document. | Small, 56.0 | 56.0 | | contentVersion | [Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_record.htm "The field data, API name, child relationship data, and record type information for a record.") | The record associated with the content document. Creating a new content version also creates a content document. | Small, 56.0 | 56.0 | #### See Also - [Upload a File](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_contentversion.htm "Upload a file such as a document or image.") - [Upload a New File Version](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_contentdocument.htm "Upload a new document or image version.") # Content Input Upload a file or a new file version. To upload a file or a new file version, provide the binary file in a multipart/form-data body part where name="fileData". See [Upload Binary Files](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_features_records_binary_upload.htm "If a record has a Base64 field, you can upload binary data to the field when you create or update a record.") and [Upload Files](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_features_records_content_document.htm "Upload documents and images or update the file with a new version."). Example for Uploading a File POST /ui-api/records/content-documents/content-versions { "description": "A description of the product", "title": "product\_image" } Example for Uploading a New Version of a File POST /ui-api/records/content-documents/0692L00000BDVevQAH/content-versions { "description": "Version 2 of the product image", "title": "product\_image" } Properties | Name | Type | Description | Required or Optional | Available Version | | --- | --- | --- | --- | --- | | description | String | A description of the document or image to be uploaded. | Optional | 56.0 | | title | String | The title of the document or image to be uploaded. | Optional | 56.0 | #### See Also - [Upload a New File Version](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_contentdocument.htm "Upload a new document or image version.") - [Upload a File](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_contentversion.htm "Upload a file such as a document or image.") # Create a Batch of Records Create multiple records. You can create, update, and delete up to 200 records in a single request. Resource /ui-api/records/batch Available Version 59.0 HTTP Method POST Example This example creates an account and a contact, and updates a record. POST /ui-api/records/batch { "allOrNone": false, "operations": \[ { "type": "CREATE", "records": \[ { "apiName": "Account", "fields": { "Name": "Global Media" } }, { "apiName": "Contact", "fields": { "LastName": "Smith" } } \] }, { "type": "Update", "records": \[ { "fields": { "Id": "001xx000003Gaf9AAC", "NumberOfEmployees": 1000 } } \] } \] } Request Body | Name | Type | Description | Required or Optional | Available Version | | --- | --- | --- | --- | --- | | recordInput | [Batch Record Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_batch_input.htm "A description of multiple operations for a request to create, update, or delete a batch of records.") | The batch of record input. | Required | 59.0 | Request Parameters
Name Type Description Required or Optional Available Version
useDefaultRule Boolean

For a Case or Lead, specifies whether to use the default (active) assignment rule. If you specify useDefaultRule, don’t specify an assignmentRuleId.

For an Account, specifies whether to apply the default territory assignment rules.

The default value is false.

See AssignmentRuleHeader in SOAP API Developer Guide.

Optional 64.0
Response Body [Batch Results](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_batch_results.htm#ui_api_responses_batch_results "The results from a request to a batch resource. Results include information for each subrequest in the batch.") Usage When creating a batch of records, you must include the required apiName field in [Batch Operation Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_batch_operation_input.htm "Represents the operation type and record data to create, update, and delete in a batch."). Don’t include the Id field. Otherwise, a 400 HTTP status code with an INVALID\_BATCH\_REQUEST error is returned. Receiving a 400 HTTP status code with an INVALID\_INPUT error can be caused by one of these reasons. - The operations field is missing or empty. - The operation type is missing. - The operations field doesn’t contain a records field or the records field is empty. #### See Also - [Update a Batch of Records](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_batch_update.htm "Update multiple records. You can create, update, and delete up to 200 records in a single request.") - [Delete a Batch of Records](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_batch_delete.htm "Delete multiple records. You can create, update, and delete up to 200 records in a single request.") # Create a Favorite Create a favorite. Resource /ui-api/favorites Available Version 41.0 HTTP Method POST Example POST /ui-api/favorites/ { name: "Most Important Accounts", sortOrder: 1 target: "00BR0000000tTTwMAM", targetType: "ListView" } Request Parameters
Name Type Description Required or Optional Available Version
name String The name of the favorite. Optional 41.0
sortOrder Integer The sort order of the favorite, from 1 to N. Optional 41.0
target String The record, API name, or content being favorited. Required 41.0
targetType String The type of favorite. One of these values:
  • ListView—A favorited list view.
  • ObjectHome—A favorited object home.
  • Record—A favorited record.
  • Tab—A favorited tab.
Required 41.0
Request Body [Favorite Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_favorite_input.htm "A favorite to create or update.") Response Body [Favorite](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_favorite.htm#ui_api_responses_favorite "A single favorite.") # Create a List View for an Object Create a list view associated with an object. Resource /ui-api/list-info/${objectApiName} Available version 61.0 HTTP methods POST Example This example uses a request body to create the metadata for an account list view. POST /services/data/v68.0/ui-api/list-info/Account { "listViewApiName": "MyAccountListView", "filteredByInfo": \[ { "fieldApiName": "Name", "operandLabels": \[ "This", "That"\], "operator": "Equals" }, { "fieldApiName": "Phone", "operandLabels": \[ "919"\], "operator": "StartsWith" }, { "fieldApiName": "AnnualRevenue", "operandLabels": \[ "1000000"\], "operator": "GreaterThan" } \], "filterLogicString" : "(1 OR 2) AND 3", "label": "Accounts opened this year", "scope": { "apiName": "entity", "entityId": "00Gxx000000sjI8", "relatedEntityId": "701xx000003HZ7X" }, "visibility": "Public" } Request parameters for POST | Parameter Name | Type | Description | Required or Optional | Available Version | | --- | --- | --- | --- | --- | | listInfoInput | [List Info Post Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_list_info_post_input.htm "Info to create a list.") | Info to create a list. | Required | 61.0 | Response body for POST [List Info](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_list_metadata.htm "Metadata that describes a list.") # Create or Clone a Record Create or clone a record. ## Usage To create or clone a record, pass a [Record Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_record_input.htm "A description of a record to use in a request to create or update a record or in a request to check for duplicate records.") request body to the POST /ui-api/records resource. To create the request body, you must know the fields, required fields, and default values for that object. You may also want layout information. If you don’t want layout information, use the lightweight resources. To find the required fields, fields, and default values, make a request to one of these resources. - [Get Default Values to Create a Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_defaults_create.htm "Get the default values for fields for a new record of a specified object and optional record type. After getting the default values, make a request to POST /ui-api/records to create the record.") - [Get Default Values to Create a Record—Lightweight](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_defaults_template_create.htm "Get the default values for fields for a new record of a specified object and optional record type. You must specify the fields you want returned. This resource doesn’t use or return layout information. After getting the default values, make a request to POST /ui-api/records to create the record.") - [Get Default Values to Clone a Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_defaults_clone.htm "Get the default layout information, object information, and data for cloning a record. After getting the default values, make a request to POST /ui-api/records to create the record.") - [Get Default Values to Clone a Record—Lightweight](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_defaults_template_clone.htm "Get the default values for fields for cloning a record. You must specify the fields you want returned. This resource doesn’t use or return layout information. After getting the default values, make a request to POST /ui-api/records to create the record.") The response from these resources includes [Object Info](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_object_info.htm "The metadata for an object."), including all fields and a required property for each field. To find the values for lookup fields, picklist fields, and multi-select picklist fields, use these resources. - [Get Lookup Field Suggestions for a Specified Object](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_lookup_object_get.htm "When a user edits a lookup field, use this resource to search for and display suggestions for a specified object. You can search for most recently used matches, for matching names, or for any match in a searchable field. You can also specify lookup filter bindings for dependent lookups.") - [Get Lookup Field Suggestions](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_lookup_get.htm "When a user edits a lookup field, use this resource to search for and display suggestions. You can search for most recently used matches, for matching names, or for any match in a searchable field. You can also specify lookup filter bindings for dependent lookups.") - [Get Values for a Picklist Field](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_picklist_values.htm "If a field’s dataType property is equal to Picklist or MultiPicklist, use this resource to get its values.") - [Get Values for All Picklist Fields of a Record Type](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_picklist_values_collection.htm "Use this resource to get the values for all the picklist fields of a specific record type. This resource is especially useful for getting dependent picklist values. For example, if an object has a tree of dependent picklists (Continents__c, Countries__c, Cities__c), use this resource to get all the values for each picklist in one request.") As of API version 43.0, if you pass read-only fields in a request body, the response is an [Error with Output](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_error_with_output.htm#ui_api_responses_error_with_output "Contains extra information about errors. In rare cases, an error message isn't enough to describe the reason for a failure. For example, when a conflicting precondition exists, the error result can include the information about the cause of the conflict."). ![Note](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/images/icon_note.png) #### Note ProductMedia records can’t be created with this resource. Use the [ProductMedia object API](https://developer.salesforce.com/docs/atlas.en-us.264.0.object_reference.meta/object_reference/sforce_api_objects_productmedia.htm) instead. Resource /ui-api/records Available Version 41.0 HTTP Method POST Example POST /ui-api/records { "apiName": "Account", "fields": { "Name": "Universal Containers" } } To provide an address, provide the individual fields as separate inputs. The compound field is only available in the response. { "apiName": "Account", "fields" : { "Name": "Local Boxes", "BillingState": "WA", "BillingStreet" : "123 Main Street", "BillingCountry" : "USA" } } Request Parameters
Parameter Name Type Description Required or Optional Available Version
allowSaveOnDuplicate Boolean Specifies whether to save a duplicate record. The default value is false. Optional 43.0
handleOwnerChange Boolean Specifies whether to return a 204 No Content HTTP status code if the context user loses access to the record during creation. The default value is false. When false, if the context user loses access to the record during creation, creation completes successfully, however the resource returns an incorrect 404 Not found HTTP status code. Optional 60.0
triggerOtherEmail Boolean For a Case, specifies whether to send email to users outside the organization. In the Salesforce user interface, this email can be automatically triggered by creating, editing, or deleting a contact for a Case.

The default value is false.

See EmailHeader in SOAP API Developer Guide.

Optional 51.0
triggerUserEmail Boolean For a Case or a Lead, specifies whether to send email to users in the organization. In the Salesforce user interface, this email can be automatically triggered by various events: resetting a password, creating a user, changing the Case owner, or adding comments to a Case.

For Case owner changes, also set useDefaultRule=true, or no email is sent.

The default value is false.

See EmailHeader in SOAP API Developer Guide.

Optional 51.0
useDefaultRule Boolean

For a Case or Lead, specifies whether to use the default (active) assignment rule. If you specify useDefaultRule, don’t specify an assignmentRuleId.

When you create an Account, as long as the account matches any filter for a territory, the Account is assigned to that territory regardless of how useDefaultRule is set.

The default value is false.

See AssignmentRuleHeader in SOAP API Developer Guide.

Optional 51.0
Request Body
Name Type Description Required or Optional Available Version
allowSaveOnDuplicate Boolean Specifies whether to save a duplicate record (true), or not (false). The default value is false.

Don’t specify this property when checking for duplicate records.

Optional 43.0
apiName String To create a record, specify the API name of an Object from which to create the record. To update a record, use null or don’t pass this property. To check for duplicate records, specify the API name of the object for which you’re performing the duplicate check. Required to create a record.

Required to check for duplicate records.

41.0
fields Map<String, Object> Map of field names to field values.

Format data types according to these rules:

  • Address—JSON String. Addresses are compound fields and must be broken up into their constituent fields. See the previous example.
  • Boolean—JSON Boolean, true or false
  • Currency—JSON Number (for example, 67.54)
  • Date—JSON string (for example, 2020-04-20)
  • DateTime—JSON string in ISO 8601 format (for example, 2012-02-18T06:40:41.000Z)
  • Double—JSON Number
  • Email—JSON String (for example, joe@smith.com)
  • EncryptedString—JSON String
  • Int—JSON Number
  • Location—JSON String. Location fields are compound fields and must be broken up into their constituent fields.
  • MultiPicklist—JSON String (for example, Dog;Cat;Fish).
  • Percent—JSON Number
  • Phone—JSON String
  • Picklist—JSON String
  • Reference—JSON String
  • String—JSON String
  • TextArea—JSON String
  • Time—JSON String in format HH:MM:SS
  • Url—JSON String

To specify the main record type, either don’t specify the RecordTypeId field, or set it to null.

Required 41.0
Response Body [Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_record.htm#ui_api_responses_record "The field data, API name, child relationship data, and record type information for a record.") #### See Also - [Upload Binary Files](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_features_records_binary_upload.htm "If a record has a Base64 field, you can upload binary data to the field when you create or update a record.") # CSRF Token Cross-Site Request Forgery (CSRF) token. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | csrfToken | String | CSRF token string. | Big, 67.0 | 67.0 | #### See Also - [Session CSRF Token](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_session_csrf.htm "Get the Cross-Site Request Forgery (CSRF) token for your session to protect requests from malicious third-party sites forgeries.") # Custom Link Layout Component A custom link component on a record page layout.
Property Name Type Description Filter Group and Version Available Version
apiName String If a field powers this component, this property contains the API name of the field. Small, 41.0 41.0
behavior String Indicates how a link behaves on open. One of these values:
  • NewWindow—Open a new window.
  • NoSidebar—No sidebar
  • OnClickJavaScript—When the link is clicked, run JavaScript.
  • Replace—Replace the current page.
  • Sidebar—Sidebar
Small, 41.0 41.0
componentType String The component type. The value is CustomLink. Small, 41.0 41.0
customLinkUrl String The custom link URL. Small, 41.0 41.0
label String The custom link label. Small, 41.0 41.0
#### See Also - [Record Layout Item](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_record_layout_item.htm "An item in a record layout.") # Delete a Batch of Records Delete multiple records. You can create, update, and delete up to 200 records in a single request. Resource /ui-api/records/batch Available Version 59.0 HTTP Method POST Example This example deletes multiple records. POST /ui-api/records/batch { "allOrNone": false, "operations": \[ { "type": "Delete", "records": \[ { "fields": { "Id": "001xx000003GanDAAS" } }, { "fields": { "Id": "001xx000003Gaf9AAC" } } \] } \] } Request Body | Name | Type | Description | Required or Optional | Available Version | | --- | --- | --- | --- | --- | | recordInput | [Batch Record Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_batch_input.htm "A description of multiple operations for a request to create, update, or delete a batch of records.") | The batch of record input. | Required | 59.0 | Response Body [Batch Results](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_batch_results.htm#ui_api_responses_batch_results "The results from a request to a batch resource. Results include information for each subrequest in the batch.") Usage When deleting a batch of records, you must include the required Id field. Don’t include the apiName field in [Batch Operation Input](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_requests_batch_operation_input.htm "Represents the operation type and record data to create, update, and delete in a batch."). You can’t perform multiple operations on the same record in one request. A delete operation using an Id value that’s used in another update or delete operation can’t be processed. Otherwise, a 400 HTTP status code with an INVALID\_BATCH\_REQUEST error is returned. Receiving a 400 HTTP status code with an INVALID\_INPUT error can be caused by one of these reasons. - The operations field is missing or empty. - The operation type is missing. - The operations field doesn’t contain a records field or the records field is empty. #### See Also - [Create a Batch of Records](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_batch_post.htm "Create multiple records. You can create, update, and delete up to 200 records in a single request.") - [Update a Batch of Records](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_records_batch_update.htm "Update multiple records. You can create, update, and delete up to 200 records in a single request.") # Delete a Favorite Delete a favorite. Resource /ui-api/favorites/${favoriteId} favoriteId—The ID of a favorite. Available Version 41.0 HTTP Method DELETE Response Body Deleting a record returns a 200 HTTP status code. # Delete a Record Delete a record. /ui-api/records/{recordId} Available Version 41.0 HTTP Method DELETE Delete a record Deleting a record returns a 200 HTTP status code. DELETE /ui-api/records/001R0000003Gjrt # Delete List View Metadata Delete list view metadata. Resource /ui-api/list-info/${objectApiName}/${listViewApiName} - objectApiName—A [supported](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_get_started_supported_objects.htm#ui_api_get_started_supported_objects "User Interface API supports all custom objects and external objects and many standard objects.") object, such as Account. - listViewApiName—The API name of a list view, such as AllAccounts. Available Version 61.0 HTTP Method DELETE Example This example deletes the metadata for a list view. The object API name is Account and the list view API name is AllAccounts. DELETE /services/data/v68.0/ui-api/list-info/Account/AllAccounts Response Deleting list view metadata returns a 204 HTTP status code. # Display Layout Search lookups target display layout metadata. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | displayFields | String\[\] | Fields to display in lookup results. | Small, 57.0 | 57.0 | # Display Layout and Matching Info Search lookups target display layout and matching information. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | displayLayout | [Display Layout](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_display_layout.htm "Search lookups target display layout metadata.") | Display information for lookup results. | Small, 57.0 | 57.0 | | matchingInfo | [Matching Info](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_matching_info.htm "Search lookups target matching information.") | Information about matching fields. | Small, 57.0 | 57.0 | # Duplicate Record Error Information about duplicate record errors. Duplicate rules are used to control whether and when you can save duplicate records within Salesforce. Duplicate rules tell Salesforce what action to take when you attempt to create a duplicate record. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | matchResults | [Match Result](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_match_result.htm#ui_api_responses_match_result "A duplicate rule match. Duplicate rules are used to control whether and when you can save duplicate records within Salesforce. Duplicate rules tell Salesforce what action to take when you attempt to create a duplicate record. Each duplicate rule requires at least one matching rule to identify which existing records are possible duplicates.")\[\] | A collection of duplicate rule match results. Each duplicate rule requires at least one matching rule to identify which existing records are possible duplicates. | Small, 41.0 | 41.0 | #### See Also - [Record Exception Error](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_record_exception_error.htm "Information about a record exception error.") # Duplicate Result Info The result of the check for duplicate records. If duplicate records exist, returns the records' IDs and the duplicate rule that was used to match the records. | Property Name | Type | Description | Filter Group and Version | Available Version | | --- | --- | --- | --- | --- | | allowSave | Boolean | Whether the duplicate record can be saved (true) or not (false). | Small, 50.0 | 50.0 | | matchResultInfo | [Match Result Info](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_responses_match_result_info.htm "Information about the results of a match.") | Information about the match result. | Small, 50.0 | 50.0 | | rule | String | Name of the duplicate rule. | Small, 50.0 | 50.0 | # Duplicate Rule Describes a duplicate rule.
Property Name Type Description Filter Group and Version Available Version
actionOnInsert String Whether users can create a duplicate record. Possible values are:
  • Allow—duplicate records can be created
  • Block—duplicate records can't be created
Small, 50.0 50.0
actionOnUpdate String Whether users can create a duplicate record while editing an existing record. Possible values are:
  • Allow—users can create a duplicate record while editing an existing record
  • Block—users can't create a duplicate record while editing an existing record
Small, 50.0 50.0
active Boolean Indicates whether the duplicate rule is active (true) or not (false). Small, 50.0 50.0
duplicateRuleFilters Duplicate Rule Filter[] A list of filters that are used by the duplicate rule. Small, 50.0 50.0
matchRules Match Rule[] A list of the match rules that are used by the duplicate rule. Small, 50.0 50.0
name String The name of the duplicate rule. Small, 50.0 50.0
[...]
